#ifndef GCC_LIBCALL_H
#define GCC_LIBCALL_H

/* Include aros/libcall.h first so that I can #undef the LP macros. */
#ifndef AROS_LIBCALL_H
#   include <aros/libcall.h>
#endif

/*
    The i386 processor doesn't have enough registers to map the m68k
    register set onto them - so simply use the compiler's calling
    convention. The library base is mapped to the last argument so that
    it can be ignored by the function.
*/

#define __RA0(type,name,basetype,basename,offset,system) \
type system##_##name(basetype basename)

#define __RA1(t,n,t1,n1,r1,bt,bn,o,s) \
t s##_##n(t1 n1,bt bn)

#define __RA2(t,n,t1,n1,r1,t2,n2,r2,bt,bn,o,s) \
t s##_##n(t1 n1,t2 n2,bt bn)

#define __RA3(t,n,t1,n1,r1,t2,n2,r2,t3,n3,r3,bt,bn,o,s) \
t s##_##n(t1 n1,t2 n2,t3 n3,bt bn)

#define __RA4(t,n,t1,n1,r1,t2,n2,r2,t3,n3,r3,t4,n4,r4,bt,bn,o,s) \
t s##_##n(t1 n1,t2 n2,t3 n3,t4 n4,bt bn)

#define __RA5(t,n,t1,n1,r1,t2,n2,r2,t3,n3,r3,t4,n4,r4,t5,n5,r5,bt,bn,o,s) \
t s##_##n(t1 n1,t2 n2,t3 n3,t4 n4,t5 n5,bt bn)

#define __RA0I(t,n,bt,bn,o,s) \
t s##_##n(void)

#define __RA1I(t,n,t1,n1,r1,bt,bn,o,s) \
t s##_##n(t1 n1)

#define __RA2I(t,n,t1,n1,r1,t2,n2,r2,bt,bn,o,s) \
t s##_##n(t1 n1,t2 n2)

#define __RA3I(t,n,t1,n1,r1,t2,n2,r2,t3,n3,r3,bt,bn,o,s) \
t s##_##n(t1 n1,t2 n2,t3 n3)

#define __RA4I(t,n,t1,n1,r1,t2,n2,r2,t3,n3,r3,t4,n4,r4,bt,bn,o,s) \
t s##_##n(t1 n1,t2 n2,t3 n3,t4 n4)

#define __RA5I(t,n,t1,n1,r1,t2,n2,r2,t3,n3,r3,t4,n4,r4,t5,n5,r5,bt,bn,o,s) \
t s##_##n(t1 n1,t2 n2,t3 n3,t4 n4,t5 n5)

#define __AROS_LH0(t,n,bt,bn,o,s) \
__RA0(t,n,bt,bn,o,s)

#define __AROS_LH1(t,n,a1,bt,bn,o,s) \
__RA1(t,n,a1,bt,bn,o,s)

#define __AROS_LH2(t,n,a1,a2,bt,bn,o,s) \
__RA2(t,n,a1,a2,bt,bn,o,s)

#define __AROS_LH3(t,n,a1,a2,a3,bt,bn,o,s) \
__RA3(t,n,a1,a2,a3,bt,bn,o,s)

#define __AROS_LH4(t,n,a1,a2,a3,a4,bt,bn,o,s) \
__RA4(t,n,a1,a2,a3,a4,bt,bn,o,s)

#define __AROS_LH5(t,n,a1,a2,a3,a4,a5,bt,bn,o,s) \
__RA5(t,n,a1,a2,a3,a4,a5,bt,bn,o,s)

#define __AROS_LH0I(t,n,bt,bn,o,s) \
__RA0I(t,n,bt,bn,o,s)

#define __AROS_LH1I(t,n,a1,bt,bn,o,s) \
__RA1I(t,n,a1,bt,bn,o,s)

#define __AROS_LH2I(t,n,a1,a2,bt,bn,o,s) \
__RA2I(t,n,a1,a2,bt,bn,o,s)

#define __AROS_LH3I(t,n,a1,a2,a3,bt,bn,o,s) \
__RA3I(t,n,a1,a2,a3,bt,bn,o,s)

#define __AROS_LH4I(t,n,a1,a2,a3,a4,bt,bn,o,s) \
__RA4I(t,n,a1,a2,a3,a4,bt,bn,o,s)

#define __AROS_LH5I(t,n,a1,a2,a3,a4,a5,bt,bn,o,s) \
__RA5I(t,n,a1,a2,a3,a4,a5,bt,bn,o,s)

#include <machine.h>

#define __LC0(type,name,basetype,basename,offset,system)  \
(((type(*)(basetype))((char*)basename-LIBVECTSIZE*offset))(basename))

#define __LC1(t,n,t1,n1,r1,bt,bn,o,s) \
(((t(*)(t1,bt))((char*)bn-LIBVECTSIZE*o))(n1,bn))

#define __LC2(t,n,t1,n1,r1,t2,n2,r2,bt,bn,o,s) \
(((t(*)(t1,t2,bt))((char*)bn-LIBVECTSIZE*o))(n1,n2,bn))

#define __LC3(t,n,t1,n1,r1,t2,n2,r2,t3,n3,r3,bt,bn,o,s) \
(((t(*)(t1,t2,t3,bt))((char*)bn-LIBVECTSIZE*o))(n1,n2,n3,bn))

#define __LC4(t,n,t1,n1,r1,t2,n2,r2,t3,n3,r3,t4,n4,r4,bt,bn,o,s) \
(((t(*)(t1,t2,t3,t4,bt))((char*)bn-LIBVECTSIZE*o))(n1,n2,n3,n4,bn))

#define __LC5(t,n,t1,n1,r1,t2,n2,r2,t3,n3,r3,t4,n4,r4,t5,n5,r5,bt,bn,o,s) \
(((t(*)(t1,t2,t3,t4,t5,bt))((char*)bn-LIBVECTSIZE*o))(n1,n2,n3,n4,n5,bn))

#define __LC0P __LC0
#define __LC1P __LC1
#define __LC1S __LC1

#define __AROS_LC0(t,n,bt,bn,o,s) __LC0(t,n,bt,bn,o,s)
#define __AROS_LC1(t,n,a1,bt,bn,o,s) __LC1(t,n,a1,bt,bn,o,s)
#define __AROS_LC2(t,n,a1,a2,bt,bn,o,s) __LC2(t,n,a1,a2,bt,bn,o,s)
#define __AROS_LC3(t,n,a1,a2,a3,bt,bn,o,s) __LC3(t,n,a1,a2,a3,bt,bn,o,s)
#define __AROS_LC4(t,n,a1,a2,a3,a4,bt,bn,o,s) __LC4(t,n,a1,a2,a3,a4,bt,bn,o,s)
#define __AROS_LC5(t,n,a1,a2,a3,a4,a5,bt,bn,o,s) __LC5(t,n,a1,a2,a3,a4,a5,bt,bn,o,s)

#define __AROS_LC0P(t,n,bt,bn,o,s) __LC0P(t,n,bt,bn,o,s)
#define __AROS_LC1P(t,n,a1,bt,bn,o,s) __LC1P(t,n,a1,bt,bn,o,s)
#define __AROS_LC1S(t,n,a1,bt,bn,o,s) __LC1S(t,n,a1,bt,bn,o,s)

/*
    Include aros/libcall.h first so that I can #undef the LP macros.
*/
#ifndef AROS_LIBCALL_H
#   include <aros/libcall.h>
#endif

#ifdef LP0
#undef LP0
#endif
#define LP0(t,n,bt,bn,o,s)

#ifdef LP1
#undef LP1
#endif
#define LP1(t,n,t1,n1,r1,bt,bn,o,s)

#ifdef LP2
#undef LP2
#endif
#define LP2(t,n,t1,n1,r1,t2,n2,r2,bt,bn,o,s)

#ifdef LP3
#undef LP3
#endif
#define LP3(t,n,t1,n1,r1,t2,n2,r2,t3,n3,r3,bt,bn,o,s)

#ifdef LP4
#undef LP4
#endif
#define LP4(t,n,t1,n1,r1,t2,n2,r2,t3,n3,r3,t4,n4,r4,bt,bn,o,s)

#ifdef LP5
#undef LP5
#endif
#define LP5(t,n,t1,n1,r1,t2,n2,r2,t3,n3,r3,t4,n4,r4,t5,n5,r5,bt,bn,o,s)

#define __AROS_ABS_CALL3(type,vec,n1,r1,n2,r2,n3,r3) \
(((type(*)(long,long,long))(vec))((long)(n1),(long)(n2),(long)(n3)))

#define __AROS_LVO_CALL0(type,offset,vec) \
__LC0(type,,long,(long)(vec),offset,)

#define __AROS_LVO_CALL1(type,offset,vec,n1,r1) \
__LC1(type,,long,(long)(n1),r1,long,(long)(vec),offset,)

#define __AROS_LVO_CALL2(type,offset,vec,n1,r1,n2,r2) \
__LC2(type,,long,(long)(n1),r1,long,(long)(n2),r2,long,(long)(vec),offset,)

#define __AROS_LVO_CALL3(type,offset,vec,n1,r1,n2,r2,n3,r3) \
__LC3(type,,long,(long)(n1),r1,long,(long)(n2),r2,long,(long)(n3),r3,long,(long)(vec),offset,)

#define __AROS_LA(a,b,c) a,b,c
#define __AROS_FUNC_INIT {
#define __AROS_FUNC_EXIT }
#define __AROS_BASE_EXT_DECL(a,b)

#endif
