#ifndef AROS_SYSTEM_H
#define AROS_SYSTEM_H
/* (C) 1995 AROS - The Amiga Replacement OS */

/******************************************************************************

    MODUL
	$Id: system.h 1.1 1995/11/05 22:30:57 digulla Exp digulla $

    DESCRIPTION
	Analyses the current type of system and sets some #defines
	to reflect this information.

******************************************************************************/

/**************************************
		Defines
**************************************/
/* 1. Analyze system */
#if defined(_AMIGA)
#   define __AROS_STRUCTURE_ALIGNMENT	     2
#elif defined(PC) /* demo */
#   define __AROS_STRUCTURE_ALIGNMENT	     1
#endif

/* 2. Makros for debugging and development */
#if defined(TEST) || defined(DEBUG)
#   include <assert.h>
#else
#   define assert(x)        /* empty */
#endif

/* 3. System-specific files */
#ifdef _AMIGA
#   include <aros/amiga.h>
#endif

/* Here we check if the system-specific files really defined everything
    they should */
#ifndef __libcall
#   define __libcall
#endif
#ifndef __asmcall
#   define __asmcall
#endif
#ifndef __reg
#   define __reg(x)
#endif

/**************************************
	       Prototypes
**************************************/


/******************************************************************************
*****  END aros/system.h
******************************************************************************/

#endif /* AROS_SYSTEM_H */
