/*
    (C) 1995 AROS - The Amiga Replacement OS
    $Id: coldreboot.c 1.1 1995/11/14 22:12:08 digulla Exp digulla $
    $Log: coldreboot.c $
 * Revision 1.1  1995/11/14  22:12:08  digulla
 * Initial revision
 *
    Desc: Reboot the machine.
    Lang: english
*/
#include "exec_intern.h"

/*****************************************************************************

    NAME */
	#include <clib/exec_protos.h>

	__AROS_LH0(void, ColdReboot,

/*  SYNOPSIS */
	/* void */

/*  LOCATION */
	struct ExecBase *, SysBase, 121, Exec)

/*  FUNCTION
	Reboot the machine, RESET all peripherals and start anew.

	This function never returns.

    INPUTS
	None.

    RESULT
	None.

    NOTES
	With AROS, this function just initalizes the system and
	does not reboot (yet).

    EXAMPLE

    BUGS

    SEE ALSO

    INTERNALS

    HISTORY
	21-10-95    digulla automatically created from
			    include:clib/exec_protos.h
	26-10-95    digulla initialize ExecBase

*****************************************************************************/
{
    __AROS_FUNC_INIT

#   if UseLVOs
    __AROS_InitExecBase ();
#   endif

    __AROS_FUNC_EXIT
} /* ColdReboot */

