/*
    (C) 1995 AROS - The Amiga Replacement OS
    $Id: freeentry.c 1.1 1995/11/14 22:31:07 digulla Exp digulla $
    $Log: freeentry.c $
 * Revision 1.1  1995/11/14  22:31:07  digulla
 * Initial revision
 *
    Desc:
    Lang: english
*/
#include "exec_intern.h"

/*****************************************************************************

    NAME */
	#include <exec/memory.h>
	#include <clib/exec_protos.h>

	__AROS_LH1(void, FreeEntry,

/*  SYNOPSIS */
	__AROS_LA(struct MemList *, entry, A0),

/*  LOCATION */
	struct ExecBase *, SysBase, 38, Exec)

/*  FUNCTION
	Free some memory allocated with AllocEntry().

    INPUTS
	entry - The MemList you got from AllocEntry().

    RESULT

    NOTES

    EXAMPLE

    BUGS

    SEE ALSO
	AllocEntry()

    INTERNALS

    HISTORY
	18-10-95    created by m. fleischer
	26-10-95    digulla adjusted to new calling scheme

******************************************************************************/
{
    __AROS_FUNC_INIT
    ULONG i;

    /* First free all blocks in the MemList */
    for (i=0; i<entry->ml_NumEntries; i++)
	FreeMem (entry->ml_ME[i].me_Addr, entry->ml_ME[i].me_Length);

    /* Then free the MemList itself */
    FreeMem (entry, sizeof (struct MemList) - sizeof (struct MemEntry)
		  + sizeof (struct MemEntry) * entry->ml_NumEntries);
    __AROS_FUNC_EXIT
} /* FreeEntry */
